Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Address_management/src/Address_management_transition.cpp	(revision 128)
@@ -28,21 +28,36 @@
       {
 	// nothing is valid
-	reg_PC_ACCESS_VAL    = 0;
-
-	reg_PC_CURRENT_VAL   = 0;
-
-        reg_PC_NEXT_VAL      = 1;
-        reg_PC_NEXT          = 0x100>>2;
-        reg_PC_NEXT_IS_DS_TAKE                  = 0;
+	reg_PC_ACCESS_VAL                               = 0;
+        reg_PC_ACCESS                                   = 0;// not necessary
+        reg_PC_ACCESS_IS_DS_TAKE                        = 0;// not necessary
+        for (uint32_t i=0; i<_param->_nb_instruction; i++)
+        reg_PC_ACCESS_INSTRUCTION_ENABLE [i]            = 0;// not necessary
+        reg_PC_ACCESS_INST_IFETCH_PTR                   = 0;// not necessary
+        reg_PC_ACCESS_BRANCH_STATE                      = 0;// not necessary
+        reg_PC_ACCESS_BRANCH_UPDATE_PREDICTION_ID       = 0;// not necessary
+
+	reg_PC_CURRENT_VAL                              = 0;
+        reg_PC_CURRENT                                  = 0;// not necessary
+        reg_PC_CURRENT_IS_DS_TAKE                       = 0;// not necessary
+        for (uint32_t i=0; i<_param->_nb_instruction; i++)
+        reg_PC_CURRENT_INSTRUCTION_ENABLE [i]           = 0;// not necessary
+        reg_PC_CURRENT_INST_IFETCH_PTR                  = 0;// not necessary
+        reg_PC_CURRENT_BRANCH_STATE                     = 0;// not necessary
+        reg_PC_CURRENT_BRANCH_UPDATE_PREDICTION_ID      = 0;// not necessary
+
+        reg_PC_NEXT_VAL                                 = 1;
+        reg_PC_NEXT                                     = 0x100>>2;
+        reg_PC_NEXT_IS_DS_TAKE                          = 0;
         uint32_t index = reg_PC_NEXT % _param->_nb_instruction;
         for (uint32_t i=0; i<_param->_nb_instruction; i++)
-        reg_PC_NEXT_INSTRUCTION_ENABLE [i]      = 0;
-        reg_PC_NEXT_INSTRUCTION_ENABLE [index]  = 1;
-        reg_PC_NEXT_INST_IFETCH_PTR             = 0;
-        reg_PC_NEXT_BRANCH_STATE                = 0;
-        reg_PC_NEXT_BRANCH_UPDATE_PREDICTION_ID = 0;
-
-
-	reg_PC_NEXT_NEXT_VAL = 0;
+        reg_PC_NEXT_INSTRUCTION_ENABLE [i]              = 0;
+        reg_PC_NEXT_INSTRUCTION_ENABLE [index]          = 1;
+        reg_PC_NEXT_INST_IFETCH_PTR                     = 0;
+        reg_PC_NEXT_BRANCH_STATE                        = 0;
+        reg_PC_NEXT_BRANCH_UPDATE_PREDICTION_ID         = 0;
+
+	reg_PC_NEXT_NEXT_VAL                            = 0;
+        reg_PC_NEXT_NEXT                                = 0;// not necessary
+        reg_PC_NEXT_NEXT_IS_DS_TAKE                     = 0;// not necessary
       }
     else
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/include/Types.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/include/Types.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/include/Types.h	(revision 128)
@@ -47,15 +47,7 @@
   public : ~ifetch_queue_entry_t (void)
     {
-      delete _instruction       ;
-      delete _instruction_enable;
+      delete [] _instruction       ;
+      delete [] _instruction_enable;
     }
-
-//   public : friend std::ostream& operator<< (std::ostream& output,
-// 					    ifetch_queue_entry_t & x)
-//     {
-//       output << ;
-//       return output;
-//     }
-
   };
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/Ifetch_queue/src/Ifetch_queue_transition.cpp	(revision 128)
@@ -31,5 +31,18 @@
 
 	for (uint32_t i=0; i<_param->_size_queue; i++)
-	  _queue [i]->_state = IFETCH_QUEUE_STATE_EMPTY;
+          {
+            _queue [i]->_state = IFETCH_QUEUE_STATE_EMPTY;
+            _queue [i]->_address                     = 0; // not necessary
+            _queue [i]->_inst_ifetch_ptr             = 0; // not necessary
+            _queue [i]->_branch_state                = 0; // not necessary
+            _queue [i]->_branch_update_prediction_id = 0; // not necessary
+            _queue [i]->_exception                   = 0; // not necessary
+
+	    for (uint32_t j=0; j<_param->_nb_instruction; j++)
+              {
+            _queue [i]->_instruction             [j] = 0; // not necessary
+            _queue [i]->_instruction_enable      [j] = 0; // not necessary
+              }
+          }
       }
     else
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Ifetch_unit/src/Ifetch_unit_deallocation.cpp	(revision 128)
@@ -60,6 +60,6 @@
         DELETE0_SIGNAL(out_DECOD_BRANCH_UPDATE_PREDICTION_ID,_param->_size_depth);
         DELETE0_SIGNAL(out_DECOD_EXCEPTION                  ,_param->_size_exception_ifetch);
-        DELETE1_SIGNAL(out_DECOD_VAL                        ,1,_param->_nb_instruction);
-        DELETE1_SIGNAL( in_DECOD_ACK                        ,1,_param->_nb_instruction);
+        DELETE1_SIGNAL(out_DECOD_VAL                        ,_param->_nb_instruction,1);
+        DELETE1_SIGNAL( in_DECOD_ACK                        ,_param->_nb_instruction,1);
         DELETE1_SIGNAL(out_DECOD_INSTRUCTION                ,_param->_nb_instruction,_param->_size_instruction);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Branch_Target_Buffer_Glue.h
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Branch_Target_Buffer_Glue.h	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/include/Branch_Target_Buffer_Glue.h	(revision 128)
@@ -82,5 +82,5 @@
   public    : SC_IN (Tcontrol_t         ) ***  in_PREDICT_REGISTER_IS_ACCURATE   ; //[nb_inst_predict][associativity]
 
-  public    : SC_IN (Tptr_t             )  **  in_PREDICT_SORT_VAL               ; //[nb_inst_predict]
+  public    : SC_IN (Tcontrol_t         )  **  in_PREDICT_SORT_VAL               ; //[nb_inst_predict]
   public    : SC_IN (Tptr_t             )  **  in_PREDICT_SORT_INDEX             ; //[nb_inst_predict]
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_allocation.cpp	(revision 128)
@@ -74,6 +74,6 @@
 	if (_param->_have_port_victim)
 	  {
-	ALLOC1_SIGNAL_IN ( in_PREDICT_SORT_VAL  ,"sort_val"  ,Tptr_t,1);
-	ALLOC1_SIGNAL_IN ( in_PREDICT_SORT_INDEX,"sort_index",Tptr_t,_param->_size_victim);
+	ALLOC1_SIGNAL_IN ( in_PREDICT_SORT_VAL      , "sort_val"      ,Tcontrol_t         ,1);
+	ALLOC1_SIGNAL_IN ( in_PREDICT_SORT_INDEX    , "sort_index"    ,Tptr_t             ,_param->_size_victim);
 
 	ALLOC1_SIGNAL_OUT(out_PREDICT_VICTIM_VAL    , "victim_val"    ,Tcontrol_t         , 1);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Glue/src/Branch_Target_Buffer_Glue_genMealy_predict.cpp	(revision 128)
@@ -38,4 +38,5 @@
         log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * val          : %d",val         );
         log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * register_ack : %d",register_ack);
+        log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * port_victim  : %d",_param->_have_port_victim);
         log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * sort_val     : %d",sort_val    );
         log_printf(TRACE,Branch_Target_Buffer_Glue,FUNCTION,"    * victim_ack   : %d",victim_ack  );
@@ -51,4 +52,5 @@
 
 	// Multiplexor
+
 	PORT_WRITE(out_PREDICT_HIT          [i],hit);
 	PORT_WRITE(out_PREDICT_ADDRESS_SRC  [i],address_src);
@@ -64,4 +66,5 @@
                                                     victim_ack
                                                     ));
+
 	PORT_WRITE(out_PREDICT_REGISTER_VAL   [i], (
                                                     val          and 
@@ -84,4 +87,5 @@
 	PORT_WRITE(out_PREDICT_VICTIM_INDEX   [i], index);
 	  }
+
       }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/Branch_Target_Buffer_Register/src/Branch_Target_Buffer_Register_transition.cpp	(revision 128)
@@ -29,5 +29,14 @@
 	for (uint32_t i=0; i<_param->_size_bank; i++)
 	  for (uint32_t j=0; j<_param->_associativity; j++)
-	    reg_BTB [i][j]._val = false;
+            {
+              reg_BTB [i][j]._val              = false;
+              reg_BTB [i][j]._context          = 0; // not necessary
+              reg_BTB [i][j]._address_dest_val = 0; // not necessary
+              reg_BTB [i][j]._address_src      = 0; // not necessary
+              reg_BTB [i][j]._address_dest     = 0; // not necessary
+              reg_BTB [i][j]._condition        = 0; // not necessary
+              reg_BTB [i][j]._last_take        = 0; // not necessary
+              reg_BTB [i][j]._accurate         = 0; // not necessary
+            }
       }
     else
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_statistics_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Branch_Target_Buffer/src/Branch_Target_Buffer_statistics_allocation.cpp	(revision 128)
@@ -35,5 +35,5 @@
       }
 
-//     _stat->add_stat(_component_branch_target_buffer_glue    ->_stat);
+    _stat->add_stat(_component_branch_target_buffer_glue    ->_stat);
     _stat->add_stat(_component_branch_target_buffer_register->_stat);
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/Meta_Predictor_Glue/src/Parameters.cpp	(revision 128)
@@ -80,4 +80,9 @@
   {
     log_begin(Meta_Predictor_Glue,FUNCTION);
+
+    DELETE1(_predictor_history_mask     ,_nb_predictor);
+    DELETE1(_predictor_history_shift_msb,_nb_predictor);
+    DELETE1(_predictor_history_shift    ,_nb_predictor);
+
     log_end(Meta_Predictor_Glue,FUNCTION);
   };
@@ -88,8 +93,4 @@
   {
     log_begin(Meta_Predictor_Glue,FUNCTION);
-
-    DELETE1(_predictor_history_mask ,_nb_predictor);
-    DELETE1(_predictor_history_shift,_nb_predictor);
-
     log_end(Meta_Predictor_Glue,FUNCTION);
   };
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_deallocation.cpp	(revision 128)
@@ -45,6 +45,8 @@
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
 
-    DELETE0(_component_glue);
-    DELETE1(_component_two_level_branch_predictor,_param->_nb_predictor);
+    delete    _component_glue;
+    for (uint32_t i=0; i<_param->_nb_predictor; ++i)
+    delete    _component_two_level_branch_predictor [i];
+    delete [] _component_two_level_branch_predictor;
 
     delete _component;
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Meta_Predictor_statistics_allocation.cpp	(revision 128)
@@ -28,4 +28,8 @@
 		      "Meta_Predictor",
 		      param_statistics);
+
+    for (uint32_t i=0; i<_param->_nb_predictor; ++i)
+    _stat->add_stat(_component_two_level_branch_predictor [i]->_stat);
+    _stat->add_stat(_component_glue                          ->_stat);
     
     log_end(Meta_Predictor,FUNCTION);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/Meta_Predictor/src/Parameters.cpp	(revision 128)
@@ -122,5 +122,8 @@
     log_begin(Meta_Predictor,FUNCTION);
 
-    DELETE1(_param_two_level_branch_predictor, _nb_predictor);
+    delete    _param_glue;
+    for (uint32_t i=0; i<_nb_predictor; ++i)
+    delete    _param_two_level_branch_predictor [i];
+    delete [] _param_two_level_branch_predictor;
 
     DELETE1(_predictor_size_history          , _nb_predictor);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_statistics_allocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_statistics_allocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Direction/src/Direction_statistics_allocation.cpp	(revision 128)
@@ -28,5 +28,7 @@
 		      param_statistics);
 
-    _stat->add_stat(_component_glue->_stat);
+    if (_param->_have_component_meta_predictor)
+    _stat->add_stat(_component_meta_predictor->_stat);
+    _stat->add_stat(_component_glue          ->_stat);
     
     log_printf(FUNC,Direction,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Return_Address_Stack/src/Return_Address_Stack_transition.cpp	(revision 128)
@@ -37,4 +37,7 @@
 // 	    reg_PREDICT_BOTTOM [i] = 0;
 	    reg_PREDICT_NB_ELT [i] = 0;
+
+            for (uint32_t j=0; j<_param->_size_queue [i]; ++j)
+            reg_stack [i][j]._address = 0; // not necessary
 	  }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Parameters.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Parameters.cpp	(revision 128)
@@ -63,5 +63,5 @@
     for (uint32_t i=0; i<_nb_thread; i++)
       _have_thread[i] = false;
-    for (uint32_t i=0; i<_nb_context; i++)
+    for (uint32_t i=0; i<_nb_thread; i++)
       _have_thread[_translate_num_context_to_num_thread [i]] = true;
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_deallocation.cpp	(revision 128)
@@ -172,9 +172,12 @@
 
 #if defined(DEBUG) and defined(DEBUG_Update_Prediction_Table) and (DEBUG_Update_Prediction_Table == true)
-    for (uint32_t i=0; i<_param->_nb_thread; ++i)
-      if (_param->_have_thread [i])
-        {
-          branchement_log_file [i].close();
-        }
+    {
+      for (uint32_t i=0; i<_param->_nb_thread; ++i)
+        if (_param->_have_thread [i])
+          {
+            branchement_log_file [i].close();
+          }
+      delete [] branchement_log_file;
+    }
 #endif
 
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_statistics_deallocation.cpp	(revision 128)
@@ -29,9 +29,13 @@
     delete    _stat;
 
-    DELETE2(_stat_nb_branch_hit            ,_param->_nb_context,MAX_BRANCH_CONDITION);
-    DELETE2(_stat_nb_branch_miss           ,_param->_nb_context,MAX_BRANCH_CONDITION);
-    DELETE1(_stat_nb_branch_unused         ,_param->_nb_context);
-    DELETE1(_stat_ufpt_queue_nb_elt        ,_param->_nb_context);
-    DELETE1(_stat_upt_queue_nb_elt         ,_param->_nb_context);
+    DELETE2(_stat_nb_branch_hit              ,_param->_nb_context,MAX_BRANCH_CONDITION);
+    DELETE2(_stat_nb_branch_miss             ,_param->_nb_context,MAX_BRANCH_CONDITION);
+    DELETE1(_stat_nb_branch_unused           ,_param->_nb_context);
+
+    DELETE1(_stat_nb_branch_ifetch_prediction,_param->_nb_context);
+    DELETE1(_stat_nb_branch_accurate         ,_param->_nb_context);
+
+    DELETE1(_stat_ufpt_queue_nb_elt          ,_param->_nb_context);
+    DELETE1(_stat_upt_queue_nb_elt           ,_param->_nb_context);
     
     log_printf(FUNC,Update_Prediction_Table,FUNCTION,"End");
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/Update_Prediction_Table/src/Update_Prediction_Table_transition.cpp	(revision 128)
@@ -34,5 +34,15 @@
 	  {
             for (uint32_t j=0; j<_param->_size_ufpt_queue[i]; ++j)
-              reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._state = UPDATE_FETCH_PREDICTION_STATE_EMPTY;
+              {
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._state            = UPDATE_FETCH_PREDICTION_STATE_EMPTY;
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._condition        = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_src      = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_dest     = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._last_take        = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._is_accurate      = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._history          = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._address_ras      = 0; // not necessary
+            reg_UPDATE_FETCH_PREDICTION_TABLE [i][j]._index_ras        = 0; // not necessary
+              }
             reg_UFPT_BOTTOM          [i] = 0;
             reg_UFPT_TOP             [i] = 0;
@@ -42,5 +52,20 @@
                                                                 
             for (uint32_t j=0; j<_param->_size_upt_queue[i]; ++j)
-              reg_UPDATE_PREDICTION_TABLE [i][j]._state = UPDATE_PREDICTION_STATE_EMPTY;
+              {
+            reg_UPDATE_PREDICTION_TABLE [i][j]._state            = UPDATE_PREDICTION_STATE_EMPTY;
+            reg_UPDATE_PREDICTION_TABLE [i][j]._condition        = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._address_src      = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._address_dest     = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._last_take        = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._good_take        = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._is_accurate      = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._history          = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._address_ras      = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._index_ras        = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._ifetch_prediction= 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._miss_commit      = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._retire_ok        = 0; // not necessary
+            reg_UPDATE_PREDICTION_TABLE [i][j]._miss_prediction  = 0; // not necessary
+              }
             reg_UPT_BOTTOM           [i] = 0;
             reg_UPT_TOP              [i] = 0;
@@ -54,7 +79,16 @@
             reg_UPT_EVENT_STATE      [i] = UPT_EVENT_STATE_OK;
 
-//             reg_EVENT_VAL            [i] = false;
-//             reg_EVENT_STATE          [i] = EVENT_STATE_OK;
-//             reg_EVENT_IS_BRANCH      [i] = true;
+            reg_EVENT_UPT_PTR          [i] = 0; // not necessary
+            reg_EVENT_UPT_FULL         [i] = 0; // not necessary
+
+//          reg_EVENT_STATE            [i] = EVENT_STATE_OK; // not necessary
+//          reg_EVENT_IS_BRANCH        [i] = true          ; // not necessary
+
+            reg_EVENT_DEPTH            [i] = 0; // not necessary
+            reg_EVENT_ADDRESS_SRC      [i] = 0; // not necessary
+            reg_EVENT_ADDRESS_DEST_VAL [i] = 0; // not necessary
+            reg_EVENT_ADDRESS_DEST     [i] = 0; // not necessary
+            reg_EVENT_CAN_CONTINUE     [i] = 0; // not necessary
+
           }
       }
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_deallocation.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_deallocation.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Prediction_unit/src/Prediction_unit_deallocation.cpp	(revision 128)
@@ -66,5 +66,5 @@
         DELETE1_SIGNAL( in_BRANCH_EVENT_ACK              ,_param->_nb_context,1);
 //      DELETE1_SIGNAL(out_BRANCH_EVENT_CONTEXT_ID       ,_param->_nb_context,_param->_size_context_id);
-//      DELETE1_SIGNAL(out_BRANCH_EVENT_DEPTH            ,_param->_nb_context,_param->_size_depth);
+        DELETE1_SIGNAL(out_BRANCH_EVENT_DEPTH            ,_param->_nb_context,_param->_size_depth);
 //      DELETE1_SIGNAL(out_BRANCH_EVENT_MISS_PREDICTION  ,_param->_nb_context,1);
         DELETE1_SIGNAL(out_BRANCH_EVENT_ADDRESS_SRC      ,_param->_nb_context,_param->_size_instruction_address);
Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp	(revision 127)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/SelfTest/src/main.cpp	(revision 128)
@@ -223,4 +223,6 @@
       
       test (name,param);
+
+      delete param;
     }
   catch (morpheo::ErrorMorpheo & error)
